## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global srcname xarray

Name:           python-%{srcname}
Version:        2025.1.1
Release:        %autorelease
Summary:        N-D labeled arrays and datasets in Python

License:        Apache-2.0
URL:            https://github.com/pydata/xarray
Source:         %pypi_source %{srcname}

# Fix test_dask_da_groupby_quantile.
Patch:          https://github.com/pydata/xarray/pull/9945.patch

# https://github.com/pydata/xarray/pull/9949
Patch:          0001-Fix-test_doc_example-on-big-endian-systems.patch
# https://github.com/pydata/xarray/pull/9964
Patch:          0002-Avoid-unsafe-casts-from-float-to-unsigned-int.patch

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  python3dist(bottleneck)
BuildRequires:  python3dist(dask[array]) >= 2023.9
BuildRequires:  python3dist(dask[dataframe]) >= 2023.9
BuildRequires:  python3dist(pint) >= 0.16
BuildRequires:  python3dist(pytest) >= 2.7.1
BuildRequires:  python3dist(pytest-xdist)
BuildRequires:  python3dist(rasterio) >= 1.1
BuildRequires:  python3dist(seaborn) >= 0.11

%global _description %{expand: \
Xarray (formerly xray) is an open source project and Python package that
makes working with labelled multi-dimensional arrays simple, efficient,
and fun!

Xarray introduces labels in the form of dimensions, coordinates and
attributes on top of raw NumPy-like arrays, which allows for a more
intuitive, more concise, and less error-prone developer experience. The
package includes a large and growing library of domain-agnostic functions
for advanced analytics and visualization with these data structures.

Xarray was inspired by and borrows heavily from pandas, the popular data
analysis package focused on labelled tabular data. It is particularly
tailored to working with netCDF files, which were the source of xarray’s
data model, and integrates tightly with dask for parallel computing.}

%description %{_description}

%package -n     python3-%{srcname}
Summary:        %{summary}
%description -n python3-%{srcname} %{_description}

%pyproject_extras_subpkg -n python3-%{srcname} io

%prep
%autosetup -n %{srcname}-%{version} -p1

%generate_buildrequires
%pyproject_buildrequires -x io

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files -l %{srcname}

%check
rm -rf xarray

pytest_args=(
  -n auto
  -m "not network"
  # this test somehow crashes python interpreter entirely, was xfail upstream till recently
  -k 'not test_save_mfdataset_compute_false_roundtrip'
)

%{pytest} -ra "${pytest_args[@]}" --pyargs xarray

%files -n python3-%{srcname} -f %{pyproject_files}
%license licenses/*
%doc README.md

%changelog
## START: Generated by rpmautospec
* Sun Jan 19 2025 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2025.1.1-3
- Fix additional architecture-specific bugs

* Sat Jan 18 2025 Fedora Release Engineering <releng@fedoraproject.org> - 2025.1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Jan 14 2025 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2025.1.1-1
- Update to latest version (#2328431)
- Remove doc subpackage; it's been disabled for a while

* Tue Jan 14 2025 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2024.10.0-2
- Add Packit configuration

* Mon Nov 11 2024 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2024.10.0-1
- Update to latest version (#2245099)

* Mon Aug 19 2024 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2024.7.0-2
- Fix tests on big-endian systems

* Mon Aug 19 2024 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2024.7.0-1
- Update to latest version (#2245099)

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2024.6.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Tue Jun 18 2024 Adam Williamson <awilliam@redhat.com> - 2024.6.0-1
- Update to latest upstream release, disable a failing test

* Thu Jun 13 2024 Gwyn Ciesla <gwync@protonmail.com> - 2023.9.0-4
- Python 3.13 rebuild

* Fri Jan 26 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2023.9.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 22 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2023.9.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Sep 27 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.9.0-1
- Update to latest version (#2240764)

* Fri Sep 15 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.8.0-1
- Update to latest version (#2232901)

* Fri Sep 15 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.7.0-2
- Fix tests with Matplotlib 3.8.0

* Thu Jul 20 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.7.0-1
- Update to latest version (#2208416)

* Wed Jul 19 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.4.2-3
- Rebuild for Python 3.12b4

* Mon May 08 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.4.2-2
- Skip flaky test

* Mon May 08 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.4.2-1
- Update to latest version (#2131120)

* Thu Jan 19 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2023.1.0-1
- Update to latest version (#2131120)

* Mon Aug 01 2022 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2022.6.0-1
- Update to latest version (#2095334)

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2022.3.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jun 21 2022 Python Maint <python-maint@redhat.com> - 2022.3.0-2
- Rebuilt for Python 3.11

* Sun Mar 06 2022 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 2022.3.0-1
- Update to latest version (#2060096)

* Sun Feb 13 2022 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.21.1-1
- Update to latest version (#2047970)

* Sat Jan 29 2022 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.21.0-1
- Update to latest version (#2047970)

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Dec 20 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.20.2-2
- Fix missing sources

* Mon Dec 20 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.20.2-1
- Update to latest version (#2030938)

* Sun Nov 28 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.20.1-1
- Update to latest version (#2019529)

* Sun Nov 28 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.19.0-4
- Switch to latest Python macros

* Fri Aug 20 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.19.0-3
- Remove old patches.

* Fri Aug 20 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.19.0-2
- Fix sources file.

* Fri Aug 20 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.19.0-1
- Update to latest version (#1985557)

* Tue Jul 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.18.2-3
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sun Jul 04 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.18.2-2
- Backport fixes to tests

* Thu Jun 17 2021 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 0.18.2-1
- Update to latest version (#1957925)
- Skip failing tests (#1969172)

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 0.17.0-2
- Rebuilt for Python 3.10

* Sat Mar 13 2021 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.17.0-1
- Update to latest version (#1933230)

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.16.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sat Dec 12 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.16.2-1
- Update to latest version (#1902888)

* Sat Sep 26 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.16.1-1
- Update to latest version (#1880864)

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.16.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Sun Jul 12 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.16.0-1
- Update to latest version

* Tue Jun 23 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.15.1-3
- Backport patch to fix tests catching too many warnings

* Tue May 26 2020 Miro Hrončok <mhroncok@redhat.com> - 0.15.1-3
- Rebuilt for Python 3.9

* Sat Apr 18 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.15.1-2
- Fix broken install with missing files
- Test against installed version to catch above issue
- Add more test dependencies

* Wed Mar 25 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.15.1-1
- Update to latest version

* Fri Mar 06 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.15.0-2
- Backport fix for seaborn 0.10.0

* Sat Feb 08 2020 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.15.0-1
- Update to latest version

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.12.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Aug 19 2019 Miro Hrončok <mhroncok@redhat.com> - 0.12.3-3
- Rebuilt for Python 3.8

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.12.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Jul 21 2019 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.12.3-1
- Update to latest version

* Sat Mar 16 2019 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.12.0-1
- Initial package.

## END: Generated by rpmautospec
